'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = BabelPluginShortIdentifiers;

var _namegen = require('./namegen');

var _namegen2 = _interopRequireDefault(_namegen);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function renameIdentifiers(path) {
  const bindings = path.scope.getAllBindings();
  const ownBindings = Object.keys(bindings).filter(b => path.scope.hasOwnBinding(b));
  const names = (0, _namegen2.default)();

  ownBindings.map(b => {
    let next = names.next().value;
    while (path.scope.hasBinding(next)) {
      next = names.next().value;
    }
    path.scope.rename(b, next);
  });
}

function BabelPluginShortIdentifiers() {
  return {
    visitor: {
      Program: renameIdentifiers,
      BlockStatement: renameIdentifiers
    }
  };
}
module.exports = exports['default'];